/// @cond EO_CXX_EO_IMPL

inline void elm::inwin::activate() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_win_inwin_activate());
}

inline void eo_cxx::elm::inwin::activate() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_win_inwin_activate());
}

inline ::eo_cxx::elm::inwin::operator ::elm::inwin() const
{
   return *static_cast<::elm::inwin const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::inwin::operator ::elm::inwin&()
{
   return *static_cast<::elm::inwin*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::inwin::operator ::elm::inwin const&() const
{
   return *static_cast<::elm::inwin const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_inwin_activate_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->activate();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::inwin >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
   {
      virtual void activate()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_win_inwin_activate());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::inwin >
{
   static constexpr int value = 
#if defined(INWIN_PROTECTED) && defined(INWIN_BETA)
      1
#elif defined(INWIN_PROTECTED)
      1
#elif defined(INWIN_BETA)
      1
#else
      1
#endif
      + operation_description_class_size<::elm::layout >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::inwin>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_inwin_activate_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_win_inwin_activate);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::inwin >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::inwin>)
{
   return (ELM_INWIN_CLASS);
}

} } }

/// @endcond

